/*                     __                                               *\
**     ________ ___   / /  ___     Scala API                            **
**    / __/ __// _ | / /  / _ |    (c) 2003, LAMP/EPFL                  **
**  __\ \/ /__/ __ |/ /__/ __ |                                         **
** /____/\___/_/ |_/____/_/ | |                                         **
**                          |/                                          **
** $Id: Undoable.scala 5359 2005-12-16 15:33:49Z dubochet $
\*                                                                      */

package scala.collection.mutable;


/** Classes that implement the <code>Undoable</code> trait provide an operation
 *  <code>undo</code> which can be used to undo the last operation.
 *  
 *  @author  Matthias Zenger
 *  @version 1.0, 08/07/2003
 */
trait Undoable {

    /** Undo the last operation.
     */
    def undo: Unit;
}
